<template>
  <div>
    <users-table></users-table>

    <div class="users-table md-layout-item md-medium-size-100 md-xsmall-size-100 md-size-100">
      <md-card class="md-card-plain">
        <md-card-content>
          <div class="group-pie-charts">
            <div class="group-pie-charts-title">
              KYC Statistics
            </div>
            <highcharts class="pie-highcharts kyc-pie-highcharts" :options="kycChartOptions"
                        ref="highcharts1"></highcharts>
            <highcharts class="pie-highcharts deposit-pie-highcharts" :options="depositChartOptions"
                        ref="highcharts2"></highcharts>

            <div class="highcharts-legend-custom">
              <template v-for="kycStatus in kycStatuses">
                <div class="highcharts-legend-custom-item">
                  <div class="circle" :style="{background: kycStatus.color}"></div>
                  <span>{{ kycStatus.kyc_name }}</span>
                </div>
              </template>
            </div>
          </div>
        </md-card-content>
      </md-card>
    </div>
  </div>
</template>
<script>
  import { UsersTable } from '../components/Tables';
  import rf from '../../common/requests/RequestFactory';

  export default {
    components: {
      UsersTable,
    },
    data () {
      return {
        title1: 0,
        title2: 0,
        kycStatuses: [
          {
            kyc_status: 0,
            kyc_name: 'Unverified',
            color: '#4a90e2',
          },
          {
            kyc_status: 1,
            kyc_name: 'Pending',
            color: '#26a6d1',
          },
          {
            kyc_status: 2,
            kyc_name: 'Verified',
            color: '#38a177',
          },
          {
            kyc_status: 3,
            kyc_name: 'Rejected',
            color: '#d0021b',
          }
        ],
        kycChartOptions: {
          chart: {
            plotBackgroundColor: null,
            plotBorderWidth: null,
            plotShadow: false,
            type: 'pie',
          },
          title: {
            text: 'All Users (0)'
          },
          tooltip: {
            pointFormat: '<b>{point.percentage:.1f}%</b>'
          },
          plotOptions: {
            pie: {
              allowPointSelect: true,
              cursor: 'default',
              dataLabels: {
                enabled: false
              },
              showInLegend: true,
            }
          },
          legend: {
            enabled: false,
          },
          series: [{
            data: []
          }]
        },
        depositChartOptions: {
          title: {
            text: 'Deposited Users (0)'
          },
          tooltip: {
            pointFormat: '<b>{point.percentage:.1f}%</b>'
          },
          chart: {
            plotBackgroundColor: null,
            plotBorderWidth: null,
            plotShadow: false,
            type: 'pie',
          },
          legend: {
            enabled: false,
          },
          plotOptions: {
            pie: {
              allowPointSelect: true,
              cursor: 'default',
              dataLabels: {
                enabled: false
              },
              showInLegend: true,
            }
          },
          series: [{
            data: []
          }]
        },

      }
    },
    methods: {
      getKYCStatistic () {
        rf.getRequest('StatisticRequest').getUserStatistic().then(res => {
          let dataset1 = [];
          let totalUserKyc = 0;
          _.forEach(res.data.all, row => {
            const item = this.kycStatuses.find((item) => item.kyc_status === row.kyc_status) || {};
            dataset1.push({
              name: item.kyc_name,
              y: row.number,
              color: item.color
            });
            totalUserKyc += row.number;
          });


          let dataset2 = [];
          let totalDepositUserKyc = 0;
          _.forEach(res.data.deposited, row => {
            const item = this.kycStatuses.find((item) => item.kyc_status === row.kyc_status) || {};
            dataset2.push({
              name: item.kyc_name,
              y: row.number,
              color: item.color
            });
            totalDepositUserKyc += row.number;
          });

          this.kycChartOptions.title.text = `All Users (${totalUserKyc || 0})`;
          this.depositChartOptions.title.text = `Deposited Users (${totalDepositUserKyc || 0})`;

          this.kycChartOptions.series = [{
            data: dataset1
          }];
          this.depositChartOptions.series = [{
            data: dataset2
          }];
        });
      }
    },
    mounted () {
      this.getKYCStatistic();
    }
  }
</script>

<style lang="scss">
  .group-pie-charts {
    font-size: 0;
    background: white;
    position: relative;
    .pie-highcharts {
      display: inline-block;
      width: 50%;
    }
    .group-pie-charts-title {
      font-size: 32px;
      text-align: center;
      padding: 30px 0px 30px;
    }
    .title-pie-1 {
      display: inline-block;
      width: 42.5%;
      font-size: 14px;
      text-align: center;
      float: left;
    }
    .title-pie-2 {
      display: inline-block;
      width: 42.5%;
      font-size: 14px;
      text-align: center;
      float: right;
    }
    .highcharts-credits {
      display: none;
    }
    .highcharts-container {
      overflow: visible !important;
    }
    .highcharts-legend-custom {
      position: relative;
      display: block;
      height: 50px;
      opacity: 1;
      color: black;
      text-align: center;
      font-size: 0;
      width: 500px;
      margin: 0px auto;
      .highcharts-legend-custom-item {
        width: 25%;
        font-size: 14px;
        display: inline-block;
        white-space: nowrap;
        color: rgb(51, 51, 51);
        font-weight: bold;
        text-overflow: ellipsis;
        cursor: pointer;
        overflow: hidden;
      }
      .circle {
        width: 12px;
        height: 12px;
        background: #4a90e2;
        border-radius: 50%;
        display: inline-block;
        margin-right: 10px;
        vertical-align: middle;
        &.univerified {
          background: #4a90e2;
        }
        &.pending {
          background: #26a6d1;
        }
        &.verified {
          background: #38a177;
        }
        &.reject {
          background: #d0021b;
        }
      }
    }
  }
</style>
